// package npm da installare
//$ npm install --save line-reader

//---------------------------------------------------------------------------------------------------------------------//
//       INPUT:  direttrice 'OLD'  con le pagine .html    e i link/immagini su www.alpini-online.it                    //
//       OUTPUT: direttrice 'OLD'  con le pagine .html    e i link/immagini su googleapis.com/ana-download/Immagini    //
//---------------------------------------------------------------------------------------------------------------------//

let fs = require("fs");
const process = require('process')
const dirIn = './APP_PAGES_OLD'        // direttrice in ingresso, con le pagine .html referenziate su https://www.alpini-online.it/Immagini
const dirOut = './APP_PAGES'           // direttrice di produzione, con le pagine .html referenziate su https://googleapis.com/ana-download/Immagini
const endOfLine = "\r\n"
let arrayPages = null                  // array con le pagine .html
let logPages = ""                    // pagine che, dopo la sostituzione, contengono qualche riferimento a www.metodologie.it
// -----------------------------------------------------------------------------
// carica l'array con le pagine .html
//const info0 = process.argv[0];
console.log(endOfLine)
console.log("*** esecuzione di  " + process.argv[1] + "  --- pagine/html, assestamenti link alle immagini per Google Cloud");
try {
    arrayPages = fs.readdirSync(dirIn);
  } catch(err) {    
    console.error(err); // An error occurred
    console.log("*** fine anomala caricamento dell'array coi files da " + dirIn);
    return
  }
// -----------------------------------------------------------------------------
// assesta e salva le pagine
for (let fileName of arrayPages){
    const pageIn = fs.readFileSync(dirIn+"/"+fileName, 'utf8')
    let pageOut = pageIn.split("www.alpini-online.it/Immagini").join("storage.googleapis.com/ana-download/Immagini")  // sostituzione per tutte le ricorrenze
    pageOut =  pageOut.split("www.alpini-online.it/immagini").join("storage.googleapis.com/ana-download/Immagini")
    pageOut =  pageOut.split("www.alpini-online.it/download").join("storage.googleapis.com/ana-download/Download")
    pageOut =  pageOut.split("www.alpini-online.it/Download").join("storage.googleapis.com/ana-download/Download")

    fs.writeFileSync(dirOut+"/"+fileName, pageOut, (err) => {
        if (err) {
          console.log(err)
          console.log("*** fine anomala nella scrittura del file " + dirOut+"/"+fileName);
          return
        }
      });
    if (pageOut.indexOf("www.alpini-online.it")>-1){
      logPages = logPages + fileName + ", "
    }
}
if (logPages){
  console.log("*** warning: pagine che, dopo la sostituzione, contengono ancora www.metodologie.it : " + logPages);  
}
console.log("*** File corretta di  " + process.argv[0] + ", " + arrayPages.length + " pagine convertite, da " + dirIn + " a " + dirOut);
console.log(endOfLine)
