// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
//   VARIABILI GLOBALI    //////////////////////////////////////////////////
//     1 : consentono di cancellare i percorsi a ogni ricalcolo della mappa
//
//                vedere:         gv_directionsDisplay.setMap(map);
//                                gv_directionsDisplay.setPanel(document.getElementById(mapPanel));
//                                gv_directionsDisplay.setDirections({ routes: [] });
//
//     2 : array dei markers
//
//
//     3 : nome della pagina corrente
//
// ------------------------------------------------------------------------
// ------------------------------------------------------------------------

var gv_directionsDisplay = new google.maps.DirectionsRenderer;
var gv_directionsService = new google.maps.DirectionsService;

var gv_markers = [];    // eventi, punti logistici e punti di interesse
var gv_markers_X = [];  // aree di interesse

var gv_kmlLayer_Z = []; // unica variabile per TUTTI i .kml

var gv_currentPage = "ICSMAP.html";


    // ------------------------------------------------------------------------
    // ------------------------------------------------------------------------
    //   FUNZIONI GENERALI   //////////////////////////////////////////////////
    // ------------------------------------------------------------------------
    // ------------------------------------------------------------------------



function pageNameConverter(oldPageName, oldParams) {
    // oldPageName = ICSMAP_APP.html                    per il sito/evento principale
    //               ICSMAPMARKER.html                  per i siti/eventi secondari
    //
    // oldParams  = ID_OBJ=<ID>|TABLE=<SITE, o NEW>|    se sito/evento principale
    //              LISTAID=ENEWS21053880,1053896| +altri, oppure LISTAID=B9SITE<ID>| + altri
    // -----------------------------------------------------------------------
    //    newPageName  : SITEA<ID>, oppure NEWA<ID>    per il sito/evento principale
    //                   SITEB<ID>, oppure NEWB<ID>    per i  siti/eventi secondari
    var newPageName = "";
    var type_obj = "";
    var id_obj = "";
    var appo = "";
    // I parte: SITO/EVENTO principale
    if (myStarstWith(oldParams, 'ID_OBJ')) {
        appo = myFindStandardParam("TABLE", oldParams);
        if (appo == "SITE") {
            type_obj = "SITE";
        }
        else {
            type_obj = "NEW"
        }
        if (oldPageName == "ICSMAP_APP.html") { // A = principale, B secondario
            type_obj = type_obj + "A";
        }
        else {
            type_obj = type_obj + "B";
        }
        if (myStarstWith(oldParams, 'ID_OBJ')) {
            appo = myFindStandardParam("ID_OBJ", oldParams);
        }
        else {
            appo = myFindStandardParam("LISTAID", oldParams);
            appo = appo.replace(/,/gi, "_");  // sostituisce la virgola con _ nelle liste con pi� ID
        }
        type_obj = type_obj + appo + ".html"; // completa il nome del file
    }
    else
    // II parte: SITO/EVENTO secondario
    {
        appo = myFindStandardParam("LISTAID", oldParams);
        if (myStarstWith(appo, 'B9SITE')) {
            type_obj = "SITE";
        }
        else {
            type_obj = "NEW";
        }
        type_obj = type_obj + "B";
        var ll = appo.length;
        appo = appo.substring(0, ll - 1);
//        appo = appo.replace(",", "_");  // cambia la virgola in _
        appo = appo.replace(/,/gi, "_");  // cambia tutte le virgole in _
        //alert("oldparams : " + oldParams + " - appo : " + appo + " - type_obj : " + type_obj);
        if (myStarstWith(appo, 'B9SITE')) {
            appo = appo.replace("B9SITE", "");
        }
        else {
            appo = appo.replace("ENEWS2", "");
        }
        //alert("appo/2 : " + appo + " - type_obj : " + type_obj);
        type_obj = type_obj + appo + ".html";
        //alert("type_obj finale : " + type_obj);        
    }
    // ------------------------------------------
    return type_obj;
}

    // ----------------------------------------
    // ESTRAE I PARAMETRI DALLA QUERY STRING

    function myParamsFromURL(name, url) {
        if (!url) {
            url = window.location.href;
            //alert("myParamsFromURL/url" + url);
            url = decodeURIComponent(url);
        }
        //alert(name, url);
        name = name.replace(/[[]]/g, "$&");
        var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
                  results = regex.exec(url);
        if (!results) return null;
        if (!results[2]) return '';
        return decodeURIComponent(results[2].replace("/+/g", " "));
    }



function myIsEmpty(val) {
    return (val === undefined || val == null || val.length <= 0) ? true : false;
}
//
function myStarstWith(fullString, startString) {
    if(myIsEmpty(fullString)) {return false;}
    if(myIsEmpty(startString)) {return false;}
    if (fullString.indexOf(startString) == 0)
    { return true }
    else
    { return false }
}

function myEndsWith(fullString, endString) {
    if (fullString.lastIndexOf(endString) == fullString.length - endString.length)
    { return true }
    else
    { return false }
}


function myIncludes(fullString, includeString) {
    var n = fullString.indexOf(includeString);
    if (n > -1)
    { return true }
    else
    { return false }
}



    function myIsPostBack() {
        // ------------------------------------------------------------------------
        //  POSTBACK : situazione in cui una pagina chiama s� stessa
        // ------------------------------------------------------------------------
        // document.referrer : URL chiamante
        // document.location.href : URL corrente
        return document.referrer.indexOf(document.location.href) > -1;
    }

    function myFindStandardParam(paramName, paramList) {
        // ------------------------------------------------------------------------
        //  Estrae il parametro [paramName] dalla lista dei parametri nel formato standard (separatore |)
        // ------------------------------------------------------------------------
        var aParams = paramList.split('|');
        paramName = paramName + "=";
        for (var i = 0; i < aParams.length; i++) {
            var p = aParams[i].trim();
            //alert('i: ' + i + ' - aParams[i] : ' + aParams[i] + ' - p ' + p);
            if (p.indexOf(paramName) == 0) { // parametro seguito dal meno in I posizione
                var valore = aParams[i].replace(paramName + "=", '');
                valore = valore.replace(paramName, '');
                //alert('i: ' + i + ' - aParams[i] : ' + aParams[i] + ' - valore ' + valore);
                return valore.trim();
            }
        }
        return '';
    }

    function myFindStandardParam_array2(paramName, paramList, uniqueField) {
        // ------------------------------------------------------------------------
        //  Estrae il parametro [paramName] dalla lista con l'array dei parametri a due livelli (separatore interno #, esterno |)
        //       >   paramName   : nome del parametro da trovare (es: FLSHOW)
        //       >   paramList   : array a due dimensioni, che deve terminare coi separatori e contiene paramName=  
        //       >   uniqueField : un campo univoco, per individuare la ricorrenza (es: ID=100215#)
        // ------------------------------------------------------------------------
        //alert(" myFindStandardParam_array2 : paramName=" + paramName +", paramList=" + paramList +", uniqueField=" + uniqueField );
        if (!myEndsWith(paramList, "#|")) {
            return '';
        }
        if (!myIncludes(paramList, uniqueField)) {
            return '';
        }
        var aParamsExt = paramList.split('|');
        for (var i = 0; i < aParamsExt.length - 1; i++) {
            //alert("aParamsExt[i] : " + aParamsExt[i]);
            if (myIncludes(aParamsExt[i], uniqueField)) {        // lista di interessi
                var aParamsInt = aParamsExt[i].split('#');  // array che inizia con paramName=
                for (var j = 0; j < aParamsInt.length; j++) {
                    var wK = aParamsInt[j];

                    if (myStarstWith(wK, paramName + "=")==true) {
                        wK = wK.replace(paramName + "=", "");
                        return wK;
                    }
                }
            }
        }
        return '';
    }

    function myChangeStandardParam_array2(paramName, paramList, uniqueField, paramNewValue) {
        // ------------------------------------------------------------------------
        //  Sostituisce il parametro [paramName] dalla lista con l'array dei parametri a due livelli (separatore interno #, esterno |)
        //       >   paramName   : nome del parametro da trovare (es: FLSHOW)
        //       >   paramList   : array a due dimensioni, che deve terminare coi separatori e contiene paramName=  
        //       >   uniqueField : un campo univoco, per individuare la ricorrenza (es: ID=100215 -NB: SENZA IL #)
        // ------------------------------------------------------------------------
//        alert("myChangeStandardParam_array2) - paramName : " + paramName + " - paramList : " + paramList +
//                                            " - uniqueField : " + uniqueField + " - paramNewValue : " + paramNewValue);
        if (!myEndsWith(paramList, "#|")) {
            return '';
        }

        if (!myIncludes(paramList, uniqueField)) {
            return '';
        }
        var aParamsExt = paramList.split('|');
        //----------------------------------------
        for (var i = 0; i < aParamsExt.length-1; i++) {

            if (myIncludes(aParamsExt[i], uniqueField + "#")) {        // lista di interessi
                var ricorrenzaOLD = aParamsExt[i];
                var aParamsInt = (ricorrenzaOLD.split('#'));  // array che inizia con paramName=
                // ---------------------
                for (var j = 0; j < aParamsInt.length-1; j++) {
                    var wK = aParamsInt[j];
                    if (myStarstWith(wK, paramName + "=") == true) {
                        aParamsInt[j] = paramName + "=" + paramNewValue;
                        var ricorrenzaNEW = "";
                        for (var k = 0; k < aParamsInt.length-1; k++) {
                            ricorrenzaNEW = ricorrenzaNEW + aParamsInt[k]+"#";
                        }
                        paramList = paramList.replace(ricorrenzaOLD, ricorrenzaNEW);
                        return paramList;
                    }
                }
            }
        }
        //----------------------------------------
        return '';
    }

    function myChangeStandardParam(paramName, paramList, paramNewValue) {
        // ------------------------------------------------------------------------
        //  1 : Cambia il valore del parametro [paramName] nella lista dei parametri nel formato standard (separatore |)
        //  2 : Restituisce paramList aggiornata
        //      > paramName : nome del parametro (es: ID)
        //      > paramList : la lista completa dei parametri, separati dal |
        //      > paramNewValue : il valore che assumer� il nuovo parametro
        // ------------------------------------------------------------------------
        var oldValue = myFindStandardParam(paramName, paramList);
        var searchValue = paramName || '=' || oldValue || '|';
        var paramListUpdated = paramList.replace(searchValue, paramName + "=" + paramNewValue + "|");
        return paramListUpdated;
    }

    function myFindLocalParam(paramName, localStorageName) {
        // ------------------------------------------------------------------------
        //  Estrae il parametro [paramName] dalla 'Local Storage' [localStorageName]
        // ------------------------------------------------------------------------
        //alert('myFindLocalParam(paramName, localStorageName) : ' + paramName + ' - ' + localStorageName);
        var params = localStorage.getItem(localStorageName);
        var aParams = params.split('|');
        paramName = paramName + "=";
        for (var i = 0; i < aParams.length; i++) {
            var p = aParams[i].trim();
            if (p.indexOf(paramName) == 0) { // parametro seguito dal meno in I posizione
                var valore = aParams[i].replace(paramName + "=", '');
                valore = valore.replace(paramName, '');
                return valore.trim();
            }
        }
        return '';
    }

    function myChangeLocalParam(paramName, localStorageName, paramNewValue) {
        // ------------------------------------------------------------------------
        //  Aggiorna il parametro [paramName] dalla 'Local Storage' [localStorageName]
        //           la valore    [paramNewValue]        
        // ------------------------------------------------------------------------
        //alert('myChangeLocalParam(paramName, localStorageName, paramNewValue) : ' + paramName + ' - ' + localStorageName + ' - ' + paramNewValue);
        var paramOldValue = myFindLocalParam(paramName, localStorageName);
        var searchValue = paramName + "=" + paramOldValue + "|";
        var localStorageOld = localStorage.getItem(localStorageName);
        var localStorageNew = localStorageOld.replace(searchValue, paramName + "=" + paramNewValue + "|");
        localStorage.setItem(localStorageName, localStorageNew);

        return localStorageNew;
    }

    // ------------------------------------------------------------------------
    //  BOOSTRAP ALERTS - ordinari      :    myAlertShow/myAlertRemove
    //                  - modali        :   myModalAlertShow/myModalAlertRemove        
    // ------------------------------------------------------------------------
    /**
    Bootstrap Alerts -
    Function Name - showalert()
    Inputs - message,alerttype
    Example - showalert("Invalid Login","alert-error")
    Types of alerts -- "alert-error","alert-success","alert-info","alert-warning"
    Required - You only need to add a alert_placeholder div in your html page wherever you want to display these alerts ""
    Written On - 14-Jun-2013
    **/

    function myAlertShow(message, alerttype, alerttime) {
        if (myIsEmpty(alerttime) == true) {
            alerttime = 5000;
        }
        $('#myAlertPlaceholderBASE').html('<div id="myAlertPlaceholder1Div" class="alert text-center ' + alerttype
                                             + '"><a class="close" data-dismiss="alert">�</a><span>' + message + '</span></div>')
        setTimeout(function () { // chiude l'alert e lo rimuove se non viene chiuso nel tempo prefissato
            $("#myAlertPlaceholder1Div").remove();
        }, alerttime);
    }
    function myAlertRemove() { // rimozione automatica dell'Alert
        //$("#myAlertPlaceholder1Div").fadeout("slow");
        $("#myAlertPlaceholder1Div").remove();
    }

    function myModalAlertShow(header, text, alerttime) {
        if (myIsEmpty(alerttime) == true) {
            alerttime = 5000;
        }
        $("#myModalAlertPlaceholderBASE .modal-title span").html(header);
        $("#myModalAlertPlaceholderBASE .modal-body span").html(text);
        $("#myModalAlertPlaceholderBASE").modal("show");  // attiva la finestra modale
        setTimeout(function () { // chiude l'alert e lo rimuove se non viene chiuso nel tempo prefissato
            $("#myModalAlertPlaceholderBASE .close").click()
        }, alerttime);
    }
    function myModalAlertHide() {
        $("#myModalAlertPlaceholderBASE .close").click()
    }


function myDetectMob() {
 if( navigator.userAgent.match(/Android/i)
 || navigator.userAgent.match(/webOS/i)
 || navigator.userAgent.match(/iPhone/i)
 || navigator.userAgent.match(/iPad/i)
 || navigator.userAgent.match(/iPod/i)
 || navigator.userAgent.match(/BlackBerry/i)
 || navigator.userAgent.match(/Windows Phone/i)
 ){
    return true;
  }
 else {
    return false;
  }
}

function myDetectBigScreen()
// PUT IN HERE A WAY TO SELECT SCREENSIZE AND RESOLUTION eg www.smashingmagazine.com/2013/03/responsive-web-design-with-physical-units/
// Including a horizontal/vertical control
   {
		var	w = window,
			d = document,
			e = d.documentElement,
			g = d.getElementsByTagName('body')[0],
			x = w.innerWidth || e.clientWidth || g.clientWidth
			y = w.innerHeight || e.clientHeight || g.clientHeight
		return  ((x >= 1000 && x >= y) || (y >= 1000 && x <= y))
	}


	//</script>



	// ------------------------------------------------------------------------
	// ------------------------------------------------------------------------
	//   MAPPE               //////////////////////////////////////////////////
	// ------------------------------------------------------------------------
	// ------------------------------------------------------------------------


	// -------------------------------------------------------------------------------------
	//  Latitudine e longitudine, da 'COORDINATE'  

	function myLat(coordinate) {
	    if (myIsEmpty(coordinate)) {return 0;}
	    var ll = coordinate.indexOf(",");
	    if (ll == -1) {return 0;}
	    return coordinate.substring(0, ll).trim();
	}

	function myLng(coordinate) {
	    if (myIsEmpty(coordinate)) {return 0;}
	    var ll = coordinate.indexOf(",");
	    if (ll == -1) {return 0;}
	    return coordinate.substring(ll + 1).trim();
	}

	function myLatN(coordinate) {
	    var s = myLat(coordinate);
	    return parseFloat(s);
	}
	function myLngN(coordinate) {
	    var s = myLng(coordinate);
	    return parseFloat(s);
	}

	function myMapFindMarkerIcon(ID_EMAPS_ICONS) {
	    var url = "https://maps.gstatic.com/mapfiles/ms2/micons/firedept.png";
	    switch (ID_EMAPS_ICONS) {
	        // Categorie degli eventi   
	        case '100881': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/100881.jpg"; break;
	        case '100882': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/100882.jpg"; break;
	        case '100883': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/100883.jpg"; break;
	        case '100884': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/100884.jpg"; break;
	        case '100885': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/100885.jpg"; break;
	        case '100888': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/1054958.png"; break;
	        // Tipologie dei siti     
	        case '13631': url = "https://maps.google.com/mapfiles/ms/icons/red-dot.png"; break;
	        case '13632': url = "https://maps.google.com/mapfiles/ms/icons/green-dot.png"; break;
	        case '13633': url = "https://maps.google.com/mapfiles/ms/icons/blue-dot.png"; break;
	        case '13647': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/13647.png"; break;
	        case '533': url = "https://maps.gstatic.com/mapfiles/ms2/micons/ltblue-dot.png"; break;
	        case '701': url = "https://www.gstatic.com/mapspro/images/stock/1239-poi-civic.png"; break;
	        case '702': url = "https://www.gstatic.com/mapspro/images/stock/1261-poi-historic-building.png"; break;
	        case '703': url = "https://www.gstatic.com/mapspro/images/stock/1315-poi-religious-christian.png"; break;
	        case '704': url = "https://maps.gstatic.com/mapfiles/ms2/micons/ylw-pushpin.png"; break;
	        case '705': url = "https://maps.gstatic.com/mapfiles/ms2/micons/ylw-pushpin.png"; break;
	        case '706': url = "https://maps.gstatic.com/mapfiles/ms2/micons/ylw-pushpin.png"; break;
	        case '709': url = "https://maps.gstatic.com/mapfiles/ms2/micons/ylw-pushpin.png"; break;
	        case '711': url = "http://maps.google.com/mapfiles/kml/pal2/icon11.png"; break;
	        case '722': url = "https://maps.gstatic.com/mapfiles/ms2/micons/rangerstation.png"; break;
	        case '723': url = "https://maps.gstatic.com/mapfiles/ms2/micons/trail.png"; break;
	        case '724': url = "https://maps.gstatic.com/mapfiles/ms2/micons/restaurant.png"; break;
	        case '726': url = "https://maps.google.com/mapfiles/kml/pal4/icon61.png"; break;

			case '716': url = "http://maps.gstatic.com/mapfiles/ms2/micons/realestate.png"; break;     // sponsor: set 2019
			case '717': url = "https://storage.googleapis.com/ana-download/Immagini/32x32/1093217.png"; break; // alpinità: gennaio 2019

	        case '720': url = "https://www.gstatic.com/mapspro/images/stock/1035-biz-hotel.png"; break;  // alberghi: ott 2018

	        case '728': url = "https://maps.gstatic.com/mapfiles/ms2/micons/parkinglot.png"; break;
	        case '729': url = "https://maps.gstatic.com/mapfiles/ms2/micons/info.png"; break;
	        case '730': url = "https://maps.gstatic.com/mapfiles/ms2/micons/hospitals.png"; break;
	        //            aggiunte 12 ago 2018  
	        case '708': url = "http://www.gstatic.com/mapspro/images/stock/1107-biz-theater.png"; break;
	        case '712': url = "http://www.gstatic.com/mapspro/images/stock/1241-poi-construction.png"; break;
	        case '713': url = "http://www.gstatic.com/mapspro/images/stock/1251-poi-fountain.png"; break;
	        case '714': url = "http://www.gstatic.com/mapspro/images/stock/1343-poi-tower.png"; break;
	        //                   
	        case '739': url = "https://maps.gstatic.com/mapfiles/ms2/micons/POI.png"; break;
	        //case '739': url = "https://maps.google.com/mapfiles/kml/shapes/target.png"; break;   
	        case '532': url = "https://maps.gstatic.com/mapfiles/ms2/micons/snowflake_simple.png"; break;
	        case '725': url = "https://maps.gstatic.com/mapfiles/ms2/micons/police.png"; break;
	        case '721': url = "https://maps.gstatic.com/mapfiles/ms2/micons/flag.png"; break;
	        case '539': url = "https://maps.gstatic.com/mapfiles/ms2/micons/earthquake.png"; break;
	        // CENTRO MAPPA  
	        case '1': url = "https://maps.google.com/mapfiles/kml/shapes/placemark_circle_highlight.png"; break;
	        // Errore  
	        case '0': url = "https://maps.gstatic.com/mapfiles/ms2/micons/firedept.png"; break;
	    }
	    return url;
	}
	












	// -------------------------------------------------------------------------------------
	//  CREAZIONE DELLA MAPPA  
	//           - riceve la lista dei parametri (MAP: ID del div della mappa, CENTER: coordinate del centro, ZOOM: zoom iniziale
	//           - crea la mappa nel div  [MAP]
    //           >>     RESTITUISCE L'OGGETTO <mappa> di Google Maps

	function myCreateMap(mapParams) {
	    var mapTAG_ID = myFindStandardParam('MAP', mapParams);
	    var zoom = parseInt(myFindStandardParam('ZOOM', mapParams));	    
        var coordinate = myFindStandardParam('CENTER', mapParams);
	    map = new google.maps.Map(document.getElementById(mapTAG_ID), {
	        center: { lat: myLatN(coordinate), lng: myLngN(coordinate) },
	        zoom: zoom
	    });
	    return map;
	}


    // -------------------------------------------------------------------------------------
    //  AGGIUNTA DEI PERCORSI DINAMICI (percorsi per coordinate)  
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : mapPanel : l'ID del DIV per il dettaglio del percorso (senza il #-ndr)
    //           -        : la lista dei percorsi, intesi come anagrafe del percorso e punti iniziali/finali ed eventualmente intermedi
    //                         mapPATH : ORIGIN=45.463979, 9.191095|DESTINATION=45.478919, 9.186906|WAYPOINTS=45.474057, 9.204967#|@
    //                                   ORIGIN=45.463979, 9.191095|DESTINATION=45.478919, 9.186906|WAYPOINTS=|TRAVELMODE=WALKING|DRAGGABLE=true|PANEL=false|@
    //                         mapPATHtypes : ID=...........#TRAVELMODE=DRIVING#DRAGGABLE=false#PANEL=true#SHOW=true#TITLE=titolo del primo percorso#|
    //                                        ID=...........#TRAVELMODE=DRIVING#DRAGGABLE=true#PANEL=true#SHOW=true#TITLE=titolo del secondo percorso#|
    //           -        : eventuali ulteriori parametri (lista normalizzata)
    //           >>     AGGIORNA LA MAPPA 
    function myMapPATH(id_mapPATH, map, mapPanel, mapPATH, mapPATHtypes, mapParams) {
        // map: oggetto mappa, nella norma gi� istamziato
        // mapPATH : coordinate dei vari percorsi, terminatore di percorso : @
        // mapPATHtypes : titoli e propriet� dei vari percorsi, terminatore di percorso : |
        //alert("mapPATH : " + mapPATH);
        if (mapPATH.lenght < 10) {
            return map;
        }
        if (myIsEmpty(map)) {
            map = myCreateMap(mapParams);
        }
        // -----------------------------------
        var arrayMapPATH = mapPATH.split("@");
        var arrayMapPATHtypes = mapPATHtypes.split("|");
        for (var i = 0; i < arrayMapPATH.length - 1; i++) {
            var singleMapPATH = arrayMapPATH[i];
            var singleMapPATHTypes = arrayMapPATHtypes[i];
            if(myIncludes(singleMapPATHTypes, "ID="+id_mapPATH+"#")){
                mySingleMapPATH(map, mapPanel, singleMapPATH, singleMapPATHTypes, mapParams);
            }
        }
        return map;
    }
    // -------------------------------------------------------------------------------------
    // -------------------------------------------------------------------------------------
    //  ELABORAZIONE DEL PERCORSO INDIVIDUALE  
    function mySingleMapPATH(map, mapPanel, singleMapPATH, singleMapPATHTypes, mapParams) {
        // risolve i parametri del percorso : ID + TRAVELMODE + DRAGGABLE + PANEL + SHOW + TITLE + |
        var arrayPATHtypes = singleMapPATHTypes.split("#");
        var pID = arrayPATHtypes[0];
        var pTravelMode = arrayPATHtypes[1];
        var pDraggable = arrayPATHtypes[2];
        var pPanel = arrayPATHtypes[3];
        var pShow = arrayPATHtypes[4];
        var pTitle = arrayPATHtypes[5];
        pID = pID.replace("ID=", "");
        pTravelMode = pTravelMode.replace("TRAVELMODE=", "");
        pDraggable = pDraggable.replace("DRAGGABLE=", "");
        pPanel = pPanel.replace("PANEL=", "");
        pShow = pShow.replace("SHOW=", "");
        pTitle = pTitle.replace("TITLE=", "");
        // risolve le coordinate del percorso : ORIGIN + DESTINATION + WAYPOINTS (possibili diversi punti intermedi) + @
        var arrayPATH = singleMapPATH.split("|");            
        var pOrigin = arrayPATH[0];
        pOrigin = pOrigin.replace("ORIGIN=", "");
        var pDestination = arrayPATH[1];
        pDestination = pDestination.replace("DESTINATION=", "");
        var pWayPoints = arrayPATH[2];
        pWayPoints = pWayPoints.replace("WAYPOINTS=", "");

        var latOrigin = myLat(pOrigin);
        var lngOrigin = myLng(pOrigin);
        var latDestination = myLat(pDestination);
        var lngDestination = myLng(pDestination);
        //-----------------------------------------
        var arrayWayPointsBase = pWayPoints.split("#"); // array con le coordinate intermedie
        var arrayWayPoints = [];                        // contenitore per gli oggetti maps intermedi
        for (var i = 0; i < arrayWayPointsBase.length - 1; i++) {
            var coord = arrayWayPointsBase[i];
            var latWayPoint = myLat(coord);
            var lngWayPoint = myLng(coord);
            var mapsWayPoint = new google.maps.LatLng(latWayPoint, lngWayPoint);
            arrayWayPoints.push({
                location: mapsWayPoint,
                stopover: true
            });
        }

        var fldirectionDraggable = false;
        if (pDraggable == "true") { fldirectionDraggable = true; }
        if (pPanel == "false") { mapPanel = "... nessun percorso ..." } // forzatura di un errore

        //-----------------------------------------
        //-----------------------------------------
        gv_directionsDisplay.setMap(map);
        gv_directionsDisplay.setPanel(document.getElementById(mapPanel));
        gv_directionsDisplay.setDirections({ routes: [] });

        var mapsOrigin = new google.maps.LatLng(myLat(pOrigin), myLng(pOrigin));
        var mapsDestination = new google.maps.LatLng(myLat(pDestination), myLng(pDestination));
        //alert("mapsOrigin : " + mapsOrigin + " - mapsDestination : " + mapsDestination + " - pTravelMode " + pTravelMode); 
        gv_directionsService.route({
            origin: mapsOrigin,
            destination: mapsDestination,
            travelMode: google.maps.TravelMode[pTravelMode]
        }, function (response, status) {
            if (status == 'OK') {
                gv_directionsDisplay.setDirections(response);
            } else {
                window.alert('Directions request failed due to ' + status);
            }
        });
        return map;
    }
    // ------------------------------------------------------------------------


    // -------------------------------------------------------------------------------------
    //  PERCORSO SEMPLIFICATO, tra due punti
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : mapPanel : l'ID del DIV per il dettaglio del percorso (senza il #-ndr)
    //           -        : coordinateStart/coordinateEnd : l'inizio e la fine del percorso
    //           -        : travelmode, draggable: true o false per le propriet� omologhe
    //           -
    //           - risolve: mapPATH : ORIGIN=[coordinateStart]|DESTINATION=[coordinateEnd]|WAYPOINTS=#|@
    //                     mapPATHtypes : ID=#TRAVELMODE=[travelmode]#DRAGGABLE=[draggable]#PANEL=[mapPanel]#SHOW=true#TITLE=#|
    //           >>     ATTIVA mySingleMapPATH


    function myMapStartEndPATH(map, mapPanel, coordinateStart, coordinateEnd, travelmode) {

//    gv_directionsDisplay = new google.maps.DirectionsRenderer;
//    gv_directionsService = new google.maps.DirectionsService;

//      NOTAZIONE ERRATA :
//          gv_directionsDisplay.setDirections({ routes: [] });
//          gv_directionsDisplay = new google.maps.DirectionsRenderer({
//            draggable: true,
//            map: map,
//            panel: document.getElementById(mapPanel)
//        });  

        //      NOTAZIONE CORRETTA IN QUESTO CASO, ma manca 'DRAGGABLE'
        gv_directionsDisplay.setMap(map);
        gv_directionsDisplay.setPanel(document.getElementById(mapPanel));
        gv_directionsDisplay.setDirections({ routes: [] });

        var mapsOrigin = new google.maps.LatLng(myLat(coordinateStart), myLng(coordinateStart));
        var mapsDestination = new google.maps.LatLng(myLat(coordinateEnd), myLng(coordinateEnd));

        gv_directionsService.route({
            origin: mapsOrigin,
            destination: mapsDestination,
            travelMode: google.maps.TravelMode[travelmode]
        }, function (response, status) {
            if (status == 'OK') {
                gv_directionsDisplay.setDirections(response);
            } else {
                //window.alert('Directions request failed due to ' + status);
            }
        });
        return map;
    }

    function myMapMarkersRemove() {
        // cancella i markers
        for (var i = 0; i < gv_markers.length; i++) {
            gv_markers[i].setMap(null);
        }
        gv_markers = []; // svuota l'array-contenitore
    }


    function myMapDirectionsRemove(map) {
        // azzera le direzioni
        gv_directionsDisplay.setMap(map);
        gv_directionsDisplay.setDirections({ routes: [] });
    }

    function myMapSetCenter(map, mapCOORDINATE_SITE, mapZOOM) {
        // centra la mappa
        var position = new google.maps.LatLng(myLat(mapCOORDINATE_SITE), myLng(mapCOORDINATE_SITE));
        map.setCenter(position);
        if (myIsEmpty(mapZOOM) == false) {
            var mapZOOM_int = parseInt(mapZOOM);
            map.setZoom(mapZOOM_int);
        }
    }



    // -------------------------------------------------------------------------------------
    //  MARKERS ORDINARI, sempre presenti sulla mappa            
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : mapPanel: il tag HTML per l'onClick del marker
    //           -        : mapMarkers: la lista dei markers
    //           -        : mapParams : i parametri della mappa
    //           >>     AGGIORNA LA MAPPA
    //           --------------------------------------------------------------------------
    function myMapMARKERSbase(map, mapPanel, mapMarkersBase, mapParams) {
        // Ciclo di caricamento dei markers  ---
        var arrayMarkersBase = mapMarkersBase.split("|");
        var infoWindow = new google.maps.InfoWindow();  //Create and open InfoWindow.

        for (i = 0; i < arrayMarkersBase.length - 1; i++) {
            var arrayMarkers = arrayMarkersBase[i].split("#");
            var ID_B9SITETYPE = arrayMarkers[4]; // tipologia del sito, per l'individuazione della URL
            var titolo = arrayMarkers[0];
            // -----------------------------------------------------------------------------------------------
            var lat = arrayMarkers[1];
            var lng = arrayMarkers[2];
            var myMapID = arrayMarkers[3]; // entit� personalizzata per l'ID della comunicazione
            var position = new google.maps.LatLng(lat, lng);
            var iconUrl = myMapFindMarkerIcon(ID_B9SITETYPE);
            marker = new google.maps.Marker({
                position: position,
                map: map,
                title: titolo,
                icon: iconUrl,
                myObjectID: myMapID
            });
            //Attach click event to the marker.
            (function (marker, myMapID, mapPanel) {
                google.maps.event.addListener(marker, "click", function (e) {
                    myMapMARKERSclick(marker, myMapID, mapPanel);
                });
            })(marker, myMapID, mapPanel);

        } // fine ciclo di caricamento dei markers
        return map;
    }

    // -------------------------------------------------------------------------------------
    //  MARKERS DI GRUPPO, a scomparsa  
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : mapMarkersTypes: i gruppi markers
    //           -        : mapMarkers: la lista dei markers
    //           -        : mapParams : i parametri della mappa
    //           >>     AGGIORNA LA MAPPA
    // -------------------------------------------------------------------------------------
    function myMapMARKERS(map, mapPanel, mapMarkersTypes, mapMarkers, mapParams) {
        // ---------------------------------------------------------------------------------------------------  
        // Gruppi di markers da esporre ---
        // ---------------------------------------------------------------------------------------------------
        if (myIsEmpty(mapMarkersTypes)) {
            return map;
        }
        var arrayMarkersTypes = mapMarkersTypes.split("|");
        var gruppiCD_GRP = "";

        for (i = 0; i < arrayMarkersTypes.length - 1; i++) {
            var riga = arrayMarkersTypes[i].split("#"); ;
            //alert("riga[0] : " + riga[0]);
            var ID = riga[0];
            ID = ID.replace("ID=", "");
            var FLSHOW = riga[1];
            FLSHOW = FLSHOW.replace("FLSHOW=", "");
            if (FLSHOW == 'true') {
                gruppiCD_GRP = gruppiCD_GRP + ID + "|"; 
            }
        }
        gruppiCD_GRP = "|" + gruppiCD_GRP;
        //alert("myMapMARKERS/gruppiCD_GRP : " + gruppiCD_GRP);
        // ---------------------------------------------------------------------------------------------------  
        // Ciclo di caricamento dei markers  ---
        // ---------------------------------------------------------------------------------------------------
        var arrayMarkersBase = mapMarkers.split("|");
        //Create and open InfoWindow.
        var infoWindow = new google.maps.InfoWindow();

        for (i = 0; i < arrayMarkersBase.length - 1; i++) {
            var arrayMarkers = arrayMarkersBase[i].split("#");
            var ID_B9SITETYPE = arrayMarkers[4]; // tipologia del sito, per l'individuazione della URL
            var CD_GRP = arrayMarkers[5]; // codice di raggruppamento, per l'identificazione del gruppo
            var titolo = arrayMarkers[0];
            var xmarker = "|" + ID_B9SITETYPE + "|";
            if (!myIncludes(gruppiCD_GRP, "|" + CD_GRP + "|")) {
                continue;
            }
            // -----------------------------------------------------------------------------------------------
            var lat = arrayMarkers[1];
            var lng = arrayMarkers[2];
            var myMapID = arrayMarkers[3]; // entit� personalizzata per l'ID della comunicazione
            var position = new google.maps.LatLng(lat, lng);
            var iconUrl = myMapFindMarkerIcon(ID_B9SITETYPE); 
            marker = new google.maps.Marker({
                position: position,
                map: map,
                title: titolo,
                icon : iconUrl,
                myObjectID: myMapID
            });

            //Attach click event to the marker.
            (function (marker, myMapID, mapPanel) {
                google.maps.event.addListener(marker, "click", function (e) {
                    //                    //dummyFunction(marker.myObjectID);
                    //                    //Wrap the content inside an HTML DIV in order to set height and width of InfoWindow.
                    //                    infoWindow.setContent("<div style = 'width:200px;min-height:40px'>" + marker.myObjectID + "</div>");
                    //                    infoWindow.open(map, marker);
                    myMapMARKERSclick(marker, myMapID, mapPanel);
                });
            })(marker, myMapID, mapPanel);

            gv_markers.push(marker);  // posiziona i markers nell'array globale
        } // fine ciclo di caricamento dei markers
        return map;
    }

    function myMapMARKERSclick(marker, myMapID, mapPanel) {
        
        // -------------------------------------------------------------
        // aggiorna il div geoCenterClicked, con la posizione del marker
        var markerPosition = marker.getPosition();
        var markerPositionChar = markerPosition.toString();
        markerPositionChar = markerPositionChar.replace("(", "");
        markerPositionChar = markerPositionChar.replace(")", "");
        $('#geoCenterClicked_Lat').attr('value', myLat(markerPositionChar));
        $('#geoCenterClicked_Lng').attr('value', myLng(markerPositionChar));
        // -----------------------------------------------------------------
        // effettua la chiamata Ajax specifica 
        myMapMARKERS_Ajax(myMapID, mapPanel);
    }

//    function myMapMARKERS_Ajax(marker, myMapID, mapPanel) {
    function myMapMARKERS_Ajax(myMapID, mapPanel) {
        var ajaxStoreProcName = 'ICSMAPMARKER.html';
        var ajaxParams = 'LISTAID=' + myMapID + '|PAGE=ICSMAP.html|MODE=PC|';
        var gvNewPageName = pageNameConverter(ajaxStoreProcName, ajaxParams);
        var gvPath = "APP_PAGES/";
        //var gvPath = "[vedi IIraggr2018Ajax.aspx.cs]";
        // $.ajax({
        //     type: "POST",
        //     url: "IIraggr2018Ajax.aspx/OnSubmit",
        //     data: "{ webPage: '" + gvNewPageName + "', webPath: '" + gvPath + "'}",
        //     contentType: 'application/json; charset=utf-8',
        //     dataType: 'json',
        //     async: false,
        //     error: function (XMLHttpRequest, textStatus, errorThrown) {
        //         alert("Request in ERROR: " + XMLHttpRequest.toString() + "\n\nStatus: " + textStatus + "\n\nError: " + errorThrown);
        //     },

        //console.log('#' + mapPanel);
        $('#' + mapPanel).load(gvPath + gvNewPageName, function() {
            successJs();
        });

        function successJs() {
                //$('#' + mapPanel).html(result.d);
                $(".dummy_UPLOADmarker").click(function (e) { // mostra gli Upload
                    e.preventDefault();
                    var id_UPLOAD = $(this).attr('id');
                    var id_UPLOAD_URL = id_UPLOAD + "_URL";
                    var id_UPLOAD_TXT = id_UPLOAD + "_TXT";
                    var url = $("#" + id_UPLOAD_URL).text();
                    var txt = $("#" + id_UPLOAD_TXT).text();
                    //window.open(url, "_blank", "toolbar=yes,scrollbars=yes,resizable=yes,top=500,left=500,width=400,height=400");
                    $("#myModalHeaderJS").text(txt);
                    var tagIframe = '<iframe name="myIframe" width="100%" height="500px" frameborder="0" scrolling="yes" allowtransparency="true" src="' + url + '"></iframe>'
                    $("#myModalBodyJS").html(tagIframe);
                    //window.open(url, "myIframe");
                    $('#myModalJS').modal('show');
                });
                $(".dummy_IMAGESmarker").click(function (e) {// mostra le immagini
                    e.preventDefault();
                    var id_IMAGE = $(this).attr('id');
                    var id_IMAGE_URL = id_IMAGE + "_URL";
                    var id_IMAGE_TXT = id_IMAGE + "_TXT";
                    var url = $("#" + id_IMAGE_URL).text();
                    var txt = $("#" + id_IMAGE_TXT).text();
                    //window.open(url, "_blank", "toolbar=yes,scrollbars=yes,resizable=yes,top=500,left=500,width=400,height=400");
                    var tagImage = '<div class="text-center"> <img src="' + url + '" class="img-fluid"></div>';
                    $("#myModalHeaderJS").html(txt);
                    $("#myModalBodyJS").html(tagImage);
                    $('#myModalJS').modal('show');
                });
                $(".dummy_VIDEOmarker").click(function (e) {// mostra i video
                    e.preventDefault();
                    var id_VIDEO = $(this).attr('id');
                    var id_VIDEO_URL = id_VIDEO + "_URL";
                    var id_VIDEO_TXT = id_VIDEO + "_TXT";
                    var url = $("#" + id_VIDEO_URL).text();
                    var txt = $("#" + id_VIDEO_TXT).text();
                    //window.open(url, "_blank", "toolbar=yes,scrollbars=yes,resizable=yes,top=500,left=500,width=400,height=400");
                    var iframe = '<div class="embed-responsive embed-responsive-16by9">'
                                + '<iframe class="embed-responsive-item" src="' + url + '" allowfullscreen="true"></iframe>'
                                + '</div>';
                    $("#myModalHeaderJS").html(txt);
                    $("#myModalBodyJS").html(iframe);
                    $('#myModalJS').modal('show');
                });

                // ------------------------------------------- 
                // dummy_MODAL, per i sub eventi: evento padre, oppure sito di riferimento
                // ------------------------------------------- 
                $(".dummy_MODALmarker").click(function (e) {
                    e.preventDefault();
                    var id_OBJ = $(this).attr('id');
                    var id_OBJx = id_OBJ.replace("button_MODALmarker_", "");
                    //alert("dummy_MODALmarker/id_OBJ : " + id_OBJ);
                    myMapMARKERS_Ajax(id_OBJx, "myModalBodyJS");
                    $("#myModalHeaderJS").html("Evento complessivo");
                    $('#myModalJS').modal('show');
                });
            }
        // });     // fine chiamata $.ajax
    }


    // -------------------------------------------------------------------------------------
    //  Inizializzazione di gv_markers_X
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : mapPanel : per le chiamate Ajax/onClick
    //           -        : mapMarkers_X: la lista dei markers
    //           >>     INIZIALIZZA gv_markers_X
    // -------------------------------------------------------------------------------------
    function myMapMARKERS_X(mapPanel, mapMarkers_X) {
        if (myIsEmpty(mapMarkers_X)) {
            return null;
        }
        // ---------------------------------------------------------------------------------------------------  
        // Ciclo di caricamento dei markers  ---
        // ---------------------------------------------------------------------------------------------------
        var arrayMarkersBase = mapMarkers_X.split("|");
        //Create and open InfoWindow.
        var infoWindow = new google.maps.InfoWindow();

        for (i = 0; i < arrayMarkersBase.length - 1; i++) {
            var arrayMarkers = arrayMarkersBase[i].split("#");
            var ID_B9SITETYPE = arrayMarkers[4]; // tipologia del sito, per l'individuazione della URL
            var CD_GRP = arrayMarkers[5]; // codice di raggruppamento, per l'identificazione del gruppo
            var titolo = arrayMarkers[0];
            var xmarker = "|" + ID_B9SITETYPE + "|";
            // -----------------------------------------------------------------------------------------------
            var lat = arrayMarkers[1];
            var lng = arrayMarkers[2];
            var myMapID = arrayMarkers[3]; // entit� personalizzata per l'ID della comunicazione
            var position = new google.maps.LatLng(lat, lng);
            var iconUrl = myMapFindMarkerIcon(ID_B9SITETYPE);
            marker = new google.maps.Marker({
                position: position,
                map: null,
                title: titolo,
                icon: iconUrl,
                myObjectID: myMapID,
                myParentID: CD_GRP
            });

            //Attach click event to the marker.
            (function (marker, myMapID, mapPanel) {
                google.maps.event.addListener(marker, "click", function (e) {
                    //                    //dummyFunction(marker.myObjectID);
                    //                    //Wrap the content inside an HTML DIV in order to set height and width of InfoWindow.
                    //                    infoWindow.setContent("<div style = 'width:200px;min-height:40px'>" + marker.myObjectID + "</div>");
                    //                    infoWindow.open(map, marker);


                    myMapMARKERSclick(marker, myMapID, mapPanel);
                });
            })(marker, myMapID, mapPanel);

            gv_markers_X.push(marker);  // posiziona i markers nell'array globale
        } // fine ciclo di caricamento dei markers
        return null;
    }


    // -------------------------------------------------------------------------------------
    //  Attivazione dei markers_X, da gv_markers_X
    //           - riceve : map - l'oggetto Mappa di Google
    //           -        : listaID_OBJ: i gruppi dei markers da attivare
    //           >>     attiva o disattiva i markers di gv_markers_X
    // -------------------------------------------------------------------------------------
    function myMapMARKERS_Xcheck(map, listaID_OBJ) {
        //alert("listaID_OBJ : " + listaID_OBJ + "  - LL : " + gv_markers_X.length);
        if (myIsEmpty(map)) {
            return null;
        }

        for (i = 0; i < gv_markers_X.length; i++) {
            var gruppo = gv_markers_X[i].myParentID;
            var marker = gv_markers_X[i];
            //alert("gruppo : " + marker.myParentID + " - ID : " + marker.myObjectID);  
            if (myIncludes(listaID_OBJ, gruppo)){
                marker.setMap( map );
            }
            else {
                marker.setMap(null);
            }

        }
    }


    // -------------------------------------------------------------------------------------		
    //  RILEVAZIONE DELLE COORDINATE  		
    function initializeGeoCenter_Map(initial_lat, initial_lng) {
        //alert("initializeGeoCenter_Map/lat/lng :" +initial_lat+ "/" + initial_lng);
        var latlng = null;
        latlng = new google.maps.LatLng(initial_lat, initial_lng); //coordinate iniziali all'apertura della mappa	
        //alert("initializeGeoCenter_Map/latlng :" + latlng);

        var myOptions = {
            zoom: 7,
            center: latlng,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };

        var mapGeoCenter = new google.maps.Map(document.getElementById('geoCenter_Map'), myOptions);
        var geoCenter_Marker = new google.maps.Marker({
            map: mapGeoCenter,
            draggable: true,
            animation: google.maps.Animation.DROP,
            position: latlng,
            icon: "https://maps.gstatic.com/mapfiles/ms2/micons/yellow-dot.png"
            //icon: "https://www.google.com/mapfiles/arrow.png"
        });

        var funPos = function (e) {
            var latlng = e.latLng;
            geoCenter_Marker.setPosition(e.latLng);
            mapGeoCenter.setCenter(latlng);
            $('#geoCenter_Lat').attr('value', e.latLng.lat());
            $('#geoCenter_Lng').attr('value', e.latLng.lng());
        }

//        var center_marker = new google.maps.Marker({
//            position: mapGeoCenter.center,
//            map: mapGeoCenter,
//            icon: "http://maps.google.com/mapfiles/kml/shapes/placemark_circle_highlight.png"
//        });
        google.maps.event.addListener(geoCenter_Marker, 'mouseup', funPos); //setta le coordinate dopo aver trascinato e rilasciato il marker/geoCenter_Marker	
    }	









    
// -----------------------------------------------------------------------
// Layers/KML - crea l'array/oggetti: gv_kmlLayer_Z
// -----------------------------------------------------------------------
//  RICEVE: lmapKML_Z,   URL + lista di ID degli oggetti
//        https://www.alpini-online.it/download/1054279.kml|ENEWS21054104#|@
//        https://www.alpini-online.it/download/1054281.kml|ENEWS21054060#|@
//        https://www.alpini-online.it/download/1054311.kml|ENEWS21048860#ENEWS21054060#|@
//        https://www.alpini-online.it/download/1054687.kml|EUPLOAD_KML1054688#|@
//        https://www.alpini-online.it/download/1054823.kml|B9SITE1035581#|@
//  >> CREA gv_kmlLayer_Z
function myMapKML_Z(mapKML) {
    if (mapKML.lenght < 10) {
        return;
    }
    //alert("< crea myMapKML_Z - ultima versione dei KML >")
    // -----------------------------------
    //alert("myMapKML_Z/mapKML : " + mapKML);
    var arrayKML = mapKML.split("@");
    for (i = 0; i < arrayKML.length - 1; i++) {
        var item = arrayKML[i];
        var arrayItem = item.split("|");
        var url = arrayItem[0];
        var listaID_OBJ = arrayItem[1];
        var kmlLayer = new google.maps.KmlLayer(url, {
            suppressInfoWindows: true,
            preserveViewport: true,
            map: null,
            listaID: listaID_OBJ
        });
        kmlLayer.addListener('click', function (kmlEvent) {
            var lat = kmlEvent.latLng.lat();
            var lng = kmlEvent.latLng.lng();
            //	            alert("lat/lng : " + lat + "/" + lng);
            $('#geoCenterClicked_Lat').attr('value', lat.toString());
            $('#geoCenterClicked_Lng').attr('value', lng.toString());
            var infoWindowHtml = kmlEvent.featureData.infoWindowHtml;
            showInContentWindow(infoWindowHtml);
        });
        function showInContentWindow(text) {
            var sidediv = document.getElementById('mapWindow');
            sidediv.innerHTML = text;
        }
        gv_kmlLayer_Z.push;
        gv_kmlLayer_Z[i] = kmlLayer;
        // -----------------------------------------------------------------------------
//        var URLstring = gv_kmlLayer_Z[i].url;
//        var listaIDstring = gv_kmlLayer_Z[i].listaID;
//        alert("URL : " + URLstring + " - listaID : " + listaIDstring);
    }
    return;
}


// -----------------------------------------------------------------------
// ATTIVA i layers presenti in listaID_OBJ
// DISATTIVA tutti gli altri
//             listaID_OBJ: ENEWS21048860|ENEWS21054072|EUPLOAD_KML1054688|
// -----------------------------------------------------------------------
//  RICEVE: lmapKML_Z,   URL + lista di ID degli oggetti
//        https://www.alpini-online.it/download/1054279.kml|ENEWS21054104#|@
//        https://www.alpini-online.it/download/1054281.kml|ENEWS21054060#|@
//        https://www.alpini-online.it/download/1054311.kml|ENEWS21048860#ENEWS21054060#|@
//        https://www.alpini-online.it/download/1054687.kml|EUPLOAD_KML1054688#|@
//        https://www.alpini-online.it/download/1054823.kml|B9SITE1035581#|@


function myMapKML_Zcheck(map, listaID_OBJ) {
    //listaID_OBJ = "EUPLOAD_KML1054688|";
    var flag = 0;
    for (i = 0; i < gv_kmlLayer_Z.length; i++) {// DISATTIVA TUTTI I LAYERS
        gv_kmlLayer_Z[i].setMap(null);    
    }
    if (myIsEmpty(listaID_OBJ)) {return;}
    if (listaID_OBJ == "|") { return; }
    //alert("listaID_OBJ : " + listaID_OBJ);
    // ----------------------------------------------------------------------------------
    // --------------------------------------      ATTIVA I LAYERS inclusi in listaID_OBJ
    var arrayID_OBJ = listaID_OBJ.split("|");      // array coi singoli ID da ATTIVARE
//    for (i = 0; i < gv_kmlLayer_Z.length - 1; i++) {
    for (i = 0; i < gv_kmlLayer_Z.length; i++) {
        var URLstring = gv_kmlLayer_Z[i].url;           // estrae la URL e la lista degli ID da gv_kmlLayer_Z
        var listaIDstring = gv_kmlLayer_Z[i].listaID;
        for (j = 0; j < arrayID_OBJ.length -1; j++) {
            if (myIncludes(listaIDstring, arrayID_OBJ[j])) {
                gv_kmlLayer_Z[i].setMap(map);      // ATTIVA IL LAYER
                //alert("* URLstring : " + URLstring + " - listaIDstring : " + listaIDstring + " - arrayID_OBJ[j] : " + arrayID_OBJ[j] + "/j=" + j);
                break;
            }
        }
    }
}






//-----------------------------------------------------------------------
//  RICEVE una lista con le classi figurative dummy_<classe>, o "ALL" per tutte (es: dummy_mapMARKERS_NEW|dummy_mapKML|)
//  RESTITUISCE listaID_OBJ, con gli ID dei checkButtons 'checked' in formato normalizzato  (es: "ENEWS21048860|ENEWS21054072|EUPLOAD_KML1054688|")
//   checkbox_mapMARKERS_NEW_    ==> ENEWS2
//   checkbox_mapMARKERS_        ==> EMAPS_ICONS
//   checkbox_mapMARKERS2_       ==> EMAPS_ICONS
//   checkbox_mapMARKERS_X_      ==> B9SITE
//   checkbox_mapKML_            ==> EUPLOAD_KML
//-----------------------------------------------------------------------
function myMapAccordion_ListaID_OBJ(listaDummyClass) {
    if (myStarstWith(listaDummyClass, "ALL")) {
        listaDummyClass = "dummy_mapMARKERS|dummy_mapMARKERS2|dummy_mapMARKERS_X|dummy_mapMARKERS_NEW|dummy_mapKML|";
    }
    if (listaDummyClass.length < 5) { return ""; }
    var listaID_OBJ = "";
    var arrayDummyClass = listaDummyClass.split("|");
    //alert("myMapAccordion_ListaID_OBJ/listaDummyClass : " + listaDummyClass);
    for (i = 0; i < arrayDummyClass.length - 1; i++) {
        var dummyClass = arrayDummyClass[i];
        //alert("myMapAccordion_ListaID_OBJ-dummyClass/i : " + dummyClass + "/" + i);
        // ------------------------------------------------------------------------
        if (myStarstWith(dummyClass, "dummy_")) {
            $("." + dummyClass).each(function (index, element) {
                var id_CheckBox = $(this).attr('id');
                var checked = $("#" + id_CheckBox).prop("checked");
                if (checked == true) {
                    if (myStarstWith(id_CheckBox, "checkbox_mapMARKERS_NEW_")) {
                        listaID_OBJ = listaID_OBJ + id_CheckBox.replace("checkbox_mapMARKERS_NEW_", "ENEWS2") + "|";
                    }
                    else {
                        if (myStarstWith(id_CheckBox, "checkbox_mapMARKERS_X_")) {
                            listaID_OBJ = listaID_OBJ + id_CheckBox.replace("checkbox_mapMARKERS_X_", "B9SITE") + "|";
                        }
                        else {
                            if (myStarstWith(id_CheckBox, "checkbox_mapMARKERS2_")) {
                                listaID_OBJ = listaID_OBJ + id_CheckBox.replace("checkbox_mapMARKERS2_", "EMAPS_ICONS") + "|";
                            }
                            else {
                                if (myStarstWith(id_CheckBox, "checkbox_mapMARKERS_")) {
                                    listaID_OBJ = listaID_OBJ + id_CheckBox.replace("checkbox_mapMARKERS_", "EMAPS_ICONS") + "|";
                                }
                                else {
                                    if (myStarstWith(id_CheckBox, "checkbox_mapKML_")) {
                                        listaID_OBJ = listaID_OBJ + id_CheckBox.replace("checkbox_mapKML_", "EUPLOAD_KML") + "|";
                                        //alert("checkbox_mapKML_/listaID_OBJ : " + listaID_OBJ);
                                    }
                                }
                            }
                        }
                    }
                }
            });
        }
        // ------------------------------------------------------------------------
        //}
    }
    //alert("myMapAccordion_ListaID_OBJ/listaID_OBJ : " + listaID_OBJ);
    return listaID_OBJ;
}


//-----------------------------------------------------------------------
//  RICEVE map, mapPanel, ... e buttonID_remove
//              button_directions_remove       : percorsi
//              button_mapMARKERS_remove       : Eventi, Logistica, POI, in gv_markers
//                                               dummy_mapMARKERS + dummy_mapMARKERS2
//                                               dummy_mapMARKERS_NEW, anche in gv_kmlLayer_Z   
//              button_mapMARKERS_X_remove     : Aree di interesse, in gv_markers_Z e gv_kmlLayer_Z
//                                               dummy_mapMARKERS_X    
//              button_mapKML_remove           : Tracce e Zone, in gv_kmlLayer_Z
//                                               dummy_mapKML    
//  RESTITUISCE map aggiornata 
//-----------------------------------------------------------------------
function myMapAccordion_Remove(map, mapPanel, mapCOORDINATE_SITE, buttonID_remove) {
    switch(buttonID_remove) {
        case "button_directions_remove":
            myMapDirectionsRemove(map);
            $("#" + mapPanel).html("");
            myMapSetCenter(map, mapCOORDINATE_SITE);
            break;
        case "button_mapMARKERS_remove":
            myMapMarkersRemove(); // rimuove tutti i markers da gv_markers : equivale a gv_markers = [];
            $(".dummy_mapMARKERS").prop("checked", false);   // aggiorna i checkbox
            $(".dummy_mapMARKERS2").prop("checked", false);
            $(".dummy_mapMARKERS_NEW").prop("checked", false);
            // -------------------------- aggiorna i .kml delle NEW
            var listaID_OBJ = myMapAccordion_ListaID_OBJ("dummy_mapMARKERS_NEW|dummy_mapMARKERS_X|dummy_mapKML|");
            myMapKML_Zcheck(map, listaID_OBJ);
            break;
        case "button_mapMARKERS_X_remove":
            $(".dummy_mapMARKERS_X").prop("checked", false);
            var listaID_OBJ = ""; 
            listaID_OBJ = myMapAccordion_ListaID_OBJ("dummy_mapMARKERS_X|");
            myMapMARKERS_Xcheck(map, listaID_OBJ);
            // -------------------------- aggiorna i .kml delle NEW
            var listaID_OBJ = myMapAccordion_ListaID_OBJ("dummy_mapMARKERS_NEW|dummy_mapMARKERS_X|dummy_mapKML|");
            myMapKML_Zcheck(map, listaID_OBJ);
            break;
        case "button_mapKML_remove":
            $(".dummy_mapKML").prop("checked", false);   // aggiorna i checkbox
            var listaID_OBJ = myMapAccordion_ListaID_OBJ("dummy_mapMARKERS_NEW|dummy_mapMARKERS_X|dummy_mapKML|");
            myMapKML_Zcheck(map, listaID_OBJ);
            break;
        default:
            alert("La funzione myMapAccordion_Remove ha ricevuto un parametro errato : [" +  buttonID_remove + "]");
    }
    return map;
}